#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get Data
$start=$ENV{QUERY_STRING};

# Get Info
$sth=$dbh->query("LOCK TABLES rw_rings READ, rw_users READ, rw_sites READ") if ($locktables);
$sth=$dbh->query("SELECT rname,rdescr,rurl,name,email,count(rw_sites.sid) FROM rw_rings,rw_users,rw_sites WHERE (rw_rings.uid=rw_users.uid AND rw_rings.rid=rw_sites.rid AND status=1) GROUP BY rw_rings.rid ORDER BY rname");
while (($fullrn,$description,$wurl,$name,$email,$total)=$sth->fetchrow)
{
	push(@data,"$fullrn\t$description\t$wurl\t$name\t$email\t$total");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
push (@footer,"<table width=\"100%\" border=0><tr>");
$icount=scalar(@data);
if (scalar (@data)>10)
{
	if ($start>0)
	{
		$pstart=$start-1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/rwgetrlist.pl?$pstart\"><img src=\"$ringworld/images/rwprev.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
	push(@footer,"<td width=\"70%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td>");
	if ($start*10+10<scalar(@data))
	{
		$nstart=$start+1;
		push(@footer,"<td width=\"15%\" align=\"center\"><a href=\"$cgi/rwgetrlist.pl?$nstart\"><img src=\"$ringworld/images/rwnext.gif\" border=0></a></td>");
	}
	else {push(@footer,"<td width=\"15%\" align=\"center\"></td>");}
}
else {push(@footer,"<td width=\"100%\" align=\"center\"><img src=\"$ringworld/images/rwline.gif\"></td>");}
push (@footer,"</tr></table>");
if ($start*10+10>scalar(@data))
{
	$i=$start*10;
	while($i<scalar(@data))
	{
		$cnt=$i+1;
		($fullrn,$description,$wurl,$name,$email,$total)=split("\t",$data[$i]);
		$fullrn=qq~<a href="$wurl" target="_blank">$fullrn</a>~ if $wurl;
		push(@result,qq~<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>$cnt. WEBRING: $fullrn ($total sites)</center></font></td></tr><tr><td width="100%"><font face="Arial" size="2"><b>Owner Name:</b> $name<br><b>Owner e-mail:</b> $email<br><b>Description:</b><br> $description</font></td></tr>\n~);
		$i++;
	}
}
else
{
	$i=$start*10;
	$last=$i+10;
	while($i<$last)
	{
		$cnt=$i+1;
		($fullrn,$description,$wurl,$name,$email,$total)=split("\t",$data[$i]);
		$fullrn=qq~<a href="$wurl" target="_blank">$fullrn</a>~ if $wurl;
		push(@result,qq~<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>$cnt. WEBRING: $fullrn ($total sites)</center></font></td></tr><tr><td width="100%"><font face="Arial" size="2"><b>Owner Name:</b> $name<br><b>Owner e-mail:</b> $email<br><b>Description:</b><br> $description</font></td></tr>\n~);
		$i++;
	}
}
if (!@result)
{
	push(@result,"<tr><td>No WebRings</td></tr>\n");
}

# Print Result
$sth="";
$dbh="";
open (F,"<$rwpath/template/ringlist.tpl");
@html=<F>;
close (F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
